<?php

// main FWD Simple 3D Gallery Data class
class FWDRMGData
{
	// constants
	const DEFAULT_SKINS_NR = 2;
	
	// variables
	public $settings_ar;
    public $playlists_ar;
	
	private $_dir_url;
	
    // constructor
    public function init()
    {
		$this->_dir_url = plugin_dir_url(dirname(__FILE__));
		
		//$this->reset_presets();
		
		$cur_data = get_option("fwdrmg_data");
   
	    if (!$cur_data)
	    {
	    	$this->init_settings();
	    	$this->set_data();
	    }
    	
    	$this->set_updates();
    	
    	$this->get_data();
    }
	
	private function reset_presets()
	{
		$this->get_data();
		$this->init_settings();
	    $this->set_data();
	}
	
	private function set_updates(){
		$this->get_data();
		
   		foreach ($this->settings_ar as &$preset){
			// update new or existing fields
			/*
	    	if (!array_key_exists("showSlideShowAnimation", $preset)){
	    		$preset["showSlideShowAnimation"] = "no";
			}						
			*/
    	}
		$this->set_data();
	}
    
    // functions
    private function init_settings()
    {
    	$this->settings_ar = array(
									array(
											//main settings
											"id" => 0,
											"name" => "minimal-skin",
											"display_type"  => "fluidwidth",
											"parentId" => "myDiv",
											"skin_path" => "minimal_skin",
											"playlistId" => "myPlaylist",
											"rightClickContextMenu" => "developer",
											"buttonsAlignment" => "out",
											"allCategoriesLabel" => "+ All categories (mixed)",
											"zindex" => 999999999,
											"useDeepLinking" => "yes",
											"autoscale" => "yes",
											"showAllCategories" => "no",
											"randomizeAllCategories" => "yes",
											"randomizeCategories" => "no",
											"slideShowAutoPlay" => "no",
											"addKeyboardSupport" => "yes",
											"showFullScreenButton" => "yes",
											"showFacebookButton" => "yes",
											"showZoomButton" => "yes",
											"showSlideShowButton" => "yes",
											"showSlideShowAnimation" => "yes",
											"showNextAndPrevButtons" => "yes",
											"showNextAndPrevButtonsOnMobile" => "yes",
											"maxwidth" => 940,
											"maxheight" => 800,
											"startAtItem" => 0,
											"buttonsHideDelay" => 3,
											"slideShowDelay" => 4,
											"defaultItemWidth" => 640,
											"defaultItemHeight" => 480,
											"itemOffsetHeight" => 40,
											"spaceBetweenButtons" => 2,
											"buttonsOffsetIn" => 4,
											"buttonsOffsetOut" => 4,
											"itemBorderSize" => 4,
											"itemBorderRadius" => 0,
											"itemBoxShadow" => "none",
											"itemBackgroundColor" => "#333333",
											"itemBorderColor" => "#FFFFFF",
											"backgroundColor" => "#000000",
											//thumbnails settings
											"showThumbnails" => "no",
											"showThumbnailsHideOrShowButton" => "yes",
											"showThumbnailsByDefault" => "yes",
											"showThumbnailsOverlay" => "yes",
											"showThumbnailsSmallIcon" => "yes",
											"thumbnailsHoverEffect" => "scale",
											"thumbnailsImageHeight" => 80,
											"thumbnailsBorderSize" => 4,
											"thumbnailsBorderRadius" => 0,
											"spaceBetweenThumbnailsAndItem" => 0,
											"thumbnailsOffsetBottom" => 0,
											"spaceBetweenThumbnails" => 2,
											"thumbnailsOverlayOpacity" => .8,
											"thumbnailsOverlayColor" => "#FFFFFF",
											"thumbnailsBorderNormalColor" => "#FFFFFF",
											"thumbnailsBorderSelectedColor" => "#FFFFFF",
											//description settings
											"descriptionWindowPosition" => "bottom",
											"showDescriptionButton" => "yes",
											"showDescriptionByDefault" => "no",
											"descriptionWindowAnimationType" => "opacity",
											"descriptionWindowBackgroundColor" => "#FFFFFF",
											"descriptionWindowBackgroundOpacity" => .9,
											//categories menu settings
											"startAtCategory" => 1,
											"showCategoriesMenuButton" => "yes",
											"buttonBackgroundNormalColor" => "#c2c2c2",
											"buttonBackgroundSelectedColor" => "#000000",
											"buttonTextNormalColor" => "#FFFFFF",
											"buttonTextSelectedColor" => "#FFFFFF",
											"buttonBackgroundOpacity" => 0.9,
											//video & audio players settings
											"useVideo" => "yes",
											"useAudio" => "yes",
											"videoShowFullScreenButton" => "yes",
											"addVideoKeyboardSupport" => "yes",
											"nextVideoOrAudioAutoPlay" => "yes",
											"videoAutoPlay" => "no",
											"videoLoop" => "no",
											"audioAutoPlay" => "no",
											"audioLoop" => "no",
											"videoControllerHideDelay" => 3,
											"videoControllerHeight" => 41,
											"audioControllerHeight" => 44,
											"startSpaceBetweenButtons" => 7,
											"vdSpaceBetweenButtons" => 9,
											"mainScrubberOffestTop" => 14,
											"scrubbersOffsetWidth" => 1,
											"audioScrubbersOffestTotalWidth" => 4,
											"timeOffsetLeftWidth" => 5,
											"timeOffsetRightWidth" => 3,
											"volumeScrubberWidth" => 80,
											"volumeScrubberOffsetRightWidth" => 0,
											"videoControllerBackgroundColor" => "#FFFFFF",
											"videoPosterBackgroundColor" => "#0099FF",
											"audioControllerBackgroundColor" => "#FFFFFF",
											"timeColor" => "#000000"
									),
					    			array(
					    					//main settings
											"id" => 1,
											"name" => "modern-skin",
											"display_type"  => "fluidwidth",
											"parentId" => "myDiv",
											"skin_path" => "modern_skin",
											"playlistId" => "myPlaylist",
											"facebookAppId" => "213684265480896",
											"rightClickContextMenu" => "developer",
											"buttonsAlignment" => "out",
											"allCategoriesLabel" => "+ All categories (mixed)",
											"zindex" => 999999999,
											"useDeepLinking" => "yes",
											"autoscale" => "yes",
											"showAllCategories" => "no",
											"randomizeAllCategories" => "yes",
											"randomizeCategories" => "no",
											"slideShowAutoPlay" => "no",
											"addKeyboardSupport" => "yes",
											"showFullScreenButton" => "yes",
											"showFacebookButton" => "yes",
											"showZoomButton" => "yes",
											"showSlideShowButton" => "yes",
											"showSlideShowAnimation" => "yes",
											"showNextAndPrevButtons" => "yes",
											"showNextAndPrevButtonsOnMobile" => "yes",
											"maxwidth" => 940,
											"maxheight" => 800,
											"startAtCategory" => 1,
											"startAtItem" => 0,
											"buttonsHideDelay" => 3,
											"slideShowDelay" => 4,
											"defaultItemWidth" => 640,
											"defaultItemHeight" => 480,
											"itemOffsetHeight" => 40,
											"spaceBetweenButtons" => 2,
											"buttonsOffsetIn" => 4,
											"buttonsOffsetOut" => 4,
											"itemBorderSize" => 4,
											"itemBorderRadius" => 0,
											"itemBoxShadow" => "none",
											"itemBackgroundColor" => "#333333",
											"itemBorderColor" => "#FFFFFF",
											"backgroundColor" => "#000000",
											//thumbnails settings
											"showThumbnails" => "no",
											"showThumbnailsHideOrShowButton" => "yes",
											"showThumbnailsByDefault" => "yes",
											"showThumbnailsOverlay" => "yes",
											"showThumbnailsSmallIcon" => "yes",
											"thumbnailsHoverEffect" => "scale",
											"thumbnailsImageHeight" => 80,
											"thumbnailsBorderSize" => 4,
											"thumbnailsBorderRadius" => 0,
											"spaceBetweenThumbnailsAndItem" => 0,
											"thumbnailsOffsetBottom" => 0,
											"spaceBetweenThumbnails" => 2,
											"thumbnailsOverlayOpacity" => .8,
											"thumbnailsOverlayColor" => "#FFFFFF",
											"thumbnailsBorderNormalColor" => "#FFFFFF",
											"thumbnailsBorderSelectedColor" => "#FFFFFF",
											//description settings
											"descriptionWindowPosition" => "bottom",
											"showDescriptionButton" => "yes",
											"showDescriptionByDefault" => "no",
											"descriptionWindowAnimationType" => "opacity",
											"descriptionWindowBackgroundColor" => "#FFFFFF",
											"descriptionWindowBackgroundOpacity" => .9,
											//categories menu settings
											"showCategoriesMenuButton" => "yes",
											"buttonBackgroundNormalColor" => "#c2c2c2",
											"buttonBackgroundSelectedColor" => "#000000",
											"buttonTextNormalColor" => "#FFFFFF",
											"buttonTextSelectedColor" => "#FFFFFF",
											"buttonBackgroundOpacity" => 0.9,
											//video & audio players settings
											"useVideo" => "yes",
											"useAudio" => "yes",
											"videoShowFullScreenButton" => "yes",
											"addVideoKeyboardSupport" => "yes",
											"nextVideoOrAudioAutoPlay" => "yes",
											"videoAutoPlay" => "no",
											"videoLoop" => "no",
											"audioAutoPlay" => "no",
											"audioLoop" => "no",
											"videoControllerHideDelay" => 3,
											"videoControllerHeight" => 41,
											"audioControllerHeight" => 44,
											"startSpaceBetweenButtons" => 7,
											"vdSpaceBetweenButtons" => 9,
											"mainScrubberOffestTop" => 14,
											"scrubbersOffsetWidth" => 1,
											"audioScrubbersOffestTotalWidth" => 4,
											"timeOffsetLeftWidth" => 5,
											"timeOffsetRightWidth" => 3,
											"volumeScrubberWidth" => 80,
											"volumeScrubberOffsetRightWidth" => 0,
											"videoControllerBackgroundColor" => "#FFFFFF",
											"videoPosterBackgroundColor" => "#0099FF",
											"audioControllerBackgroundColor" => "#FFFFFF",
											"timeColor" => "#000000"
					    			)
							      );
    }

    public function get_data()
    {
	    $cur_data = get_option("fwdrmg_data");
	       
	    $this->settings_ar = $cur_data->settings_ar;
	    $this->playlists_ar = $cur_data->playlists_ar;
    }
    
    public function set_data(){
    	update_option("fwdrmg_data", $this);
    }
}

?>